﻿using System;

namespace FluentlyXml.Core
{
	/// <summary>
	/// Performs deserialization of objects.  Maintains
	/// an identity cache until disposed, so multiple calls to Deserialize
	/// will return the same instances of objects that were previously
	/// deserialize using the same instance. 
	/// </summary>
	public interface IFluentDeserializer
	{
		T Deserialize<T>(string xml);
		object Deserialize(Type type, string xml);
	}
}